﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace RevoluionOS.Core.Desktop.Apps
{
    class Program
    {
        public static Core.Resolution.Resolution Resolution = new Resolution.Resolution();
        public static uint Contentx = 0;
        public static uint Contenty = 0;
        public static int Colorform = 0xD3D3D3;
        public static uint ColorClose = 0xCD5C5C;
        public static uint X = 0;
        public static uint Y = 0;
        public static uint Width = 0;

        public static void Draw()
        {
            Core.Graphics.Formsforuse.Forms.Rectangle(0, 1, (uint)Resolution.width, 9, Colorform);
            Core.Graphics.Formsforuse.Forms.Rectangle(1, 9, 3, (uint)Resolution.height, Colorform);
            Core.Graphics.Formsforuse.Forms.Rectangle(4, (uint)Resolution.height - 2, (uint)Resolution.width, 3, Colorform);
            Core.Graphics.Formsforuse.Forms.Rectangle(10, (uint)Resolution.width - 2, 3, (uint)Resolution.height, Colorform);


            Core.Graphics.Formsforuse.Forms.Rectangle(0, 1, (uint)Resolution.width, 1, 0x000000);
            Core.Graphics.Formsforuse.Forms.Rectangle(0, 3, (uint)Resolution.width, 1, 0x000000);
            Core.Graphics.Formsforuse.Forms.Rectangle(0, 5, (uint)Resolution.width, 1, 0x000000);
            Core.Graphics.Formsforuse.Forms.Rectangle(0, 7, (uint)Resolution.width, 1, 0x000000);
        }

        public static void DrawSmall(string text, uint x, uint y, uint height, uint width, int stripescolor)
        {
            uint Textlength;
            //Content
            Contentx = x + 7;
            Contenty = y + 20;
            X = x;
            Y = y;
            Width = width;
            Textlength = (uint)text.Length * 7;
            Core.Graphics.Formsforuse.Forms.Rectangle(Contentx, Contenty, width - 13, height - 26, 0xffffff);

            //Form
            Core.Graphics.Formsforuse.Forms.Rectangle(x + 1, y + 1, width - 1, 19, Colorform);
            Core.Graphics.Formsforuse.Forms.Rectangle(x, y, width, 1, 0x000000);
            Core.Graphics.Formsforuse.Forms.Rectangle(x + 1, y + 20, 6, height - 20, Colorform);
            Core.Graphics.Formsforuse.Forms.Rectangle(x, y + 1, 1, height, 0x000000);
            Core.Graphics.Formsforuse.Forms.Rectangle(x + 7, y + height - 6, width - 12, 6, Colorform);
            Core.Graphics.Formsforuse.Forms.Rectangle(x + 1, y + height, width, 1, 0x000000);
            Core.Graphics.Formsforuse.Forms.Rectangle(x + width - 6, y + 20, 6, height - 20, Colorform);
            Core.Graphics.Formsforuse.Forms.Rectangle(x + width, y, 1, height, 0x000000);

            //Stripes before text
            Core.Graphics.Formsforuse.Forms.Rectangle(x + 1, y + 6, 4, 1, stripescolor);
            Core.Graphics.Formsforuse.Forms.Rectangle(x + 1, y + 9, 4, 1, stripescolor);
            Core.Graphics.Formsforuse.Forms.Rectangle(x + 1, y + 12, 4, 1, stripescolor);
            Core.Graphics.Formsforuse.Forms.Rectangle(x + 1, y + 15, 4, 1, stripescolor);

            //Text
            Core.Graphics.Font.Ownfont7x8.ConvertText(text, x + 7, y + 6, 0x000000);

            //Stripes after text
            Core.Graphics.Formsforuse.Forms.Rectangle(x + 7 + Textlength + 2, y + 6, width - Textlength - 9, 1, stripescolor);
            Core.Graphics.Formsforuse.Forms.Rectangle(x + 7 + Textlength + 2, y + 9, width - Textlength - 9, 1, stripescolor);
            Core.Graphics.Formsforuse.Forms.Rectangle(x + 7 + Textlength + 2, y + 12, width - Textlength - 9, 1, stripescolor);
            Core.Graphics.Formsforuse.Forms.Rectangle(x + 7 + Textlength + 2, y + 15, width - Textlength - 9, 1, stripescolor);
        }

        public static void DrawClose()
        {
            uint x = X + Width - 17;
            uint y = Y + 6;
            Core.Graphics.Formsforuse.Forms.Draw2Colors(Close, 10, 10, x, y, 0x000000, ColorClose);//That will draw the array for the close button
        }

        public static void DrawTextField(uint x, uint y, uint width, uint length, int Background)
        {
            #region " Border "
            //the border
            Core.Graphics.Formsforuse.Forms.Rectangle(x, y, length, 2, 0xD3D3D3);
            Core.Graphics.Formsforuse.Forms.Rectangle(x, y + 2, 2, width - 2, 0xD3D3D3);
            Core.Graphics.Formsforuse.Forms.Rectangle(x + 2, y + width - 2, length - 2, 2, 0xD3D3D3);
            Core.Graphics.Formsforuse.Forms.Rectangle(x + length - 2, y + 2, 2, width - 4, 0xD3D3D3);
            #endregion

            #region " Filling "
            //the filling
            Core.Graphics.Formsforuse.Forms.Rectangle(x + 2, y + 2,  length - 4, width - 4, Background);
            #endregion
        }

        public static void DrawErrorMessage(bool manually, string Text, int x, int y, int width, int height)
        {
            if (manually == false)
            {
                width = Text.Length * 10 + 10;
                height = 39;
                x = (Resolution.width - width) / 2;
                y = (Resolution.height - height) / 2; 
            }

            DrawSmall("Error", (uint)x, (uint)y, (uint)height, (uint)width, 0x000000);

            Core.Graphics.Font.Ownfont10x11.ConvertText(Text, Contentx, Contenty, 0x000000);
        } 

        public static void DrawButton(string String, string Font,bool manually, uint x, uint y, uint width, uint length)
        {
            if (manually == false)
            {

                if (Font == "Ownfont10x11")
                {
                    width = 17;
                    length = (uint)String.Length * 10 + 4;
                }
                else if (Font == "Ownfont14x16")
                {
                    width = 16 + 6;
                    length = (uint)String.Length * 14 + 5;
                }
            }
            
            #region " Border "
            Core.Graphics.Formsforuse.Forms.Rectangle(x + 1, y, length - 2, 1, 0x383838);
            Core.Graphics.Formsforuse.Forms.Rectangle(x, y + 1, length, 1, 0x383838);

            Core.Graphics.Formsforuse.Forms.Rectangle(x, y + 2, 2, width - 4, 0x383838);

            Core.Graphics.Formsforuse.Forms.Rectangle(x, y + width - 2, length, 1, 0x383838);
            Core.Graphics.Formsforuse.Forms.Rectangle(x + 1, y + width - 1, length - 2, 1, 0x383838);

            Core.Graphics.Formsforuse.Forms.Rectangle(x + length - 2, y + 2, 2, width - 4, 0x383838);
            #endregion

            #region " Filling "
            Core.Graphics.Formsforuse.Forms.Rectangle(x + 2, y + 2, length - 4, width - 4, 0xD3D3D3);
            #endregion

            #region " Text "
            if (Font == "Ownfont10x11")
            {
                Core.Graphics.Font.Ownfont10x11.ConvertText(String, x + 3, y + 2, 0x000000);
            }
            else if (Font == "Ownfont14x16")
            {
                Core.Graphics.Font.Ownfont14x16.ConvertText(String, x + 3, y + 2, 0x000000);
            }
            #endregion
        }

        public static uint[] Closesmall = {1,2,2,2,2,2,1,
                                           2,1,2,2,2,1,2,
                                           2,2,1,2,1,2,2,
                                           2,2,2,1,2,2,2,
                                           2,2,1,2,1,2,2,
                                           2,1,2,2,2,1,2,
                                           1,2,2,2,2,2,1};//The array for the small close button (X)

        public static uint[] Close = {1,2,2,2,2,2,2,2,1,1,
                                      1,1,2,2,2,2,2,1,1,2,
                                      2,1,1,2,2,2,1,1,2,2,
                                      2,2,1,1,2,1,1,2,2,2,
                                      2,2,2,1,1,1,2,2,2,2,
                                      2,2,2,1,1,1,2,2,2,2,
                                      2,2,1,1,2,1,1,2,2,2,
                                      2,1,1,2,2,2,1,1,2,2,
                                      1,1,2,2,2,2,2,1,1,2,
                                      1,2,2,2,2,2,2,2,1,1,};//The arra for the close button (X)
    }
}
