﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace RevoluionOS.Core.Desktop.Apps
{
    class RevolutionDrawing
    {

        public static Cosmos.Hardware.VGAScreen VGAScreen = new Cosmos.Hardware.VGAScreen();

        public static void start()
        {
            string input, owncolor;
            int color = 0, owncolorR, owncolorG, owncolorB;
            bool rightinput = true, loop = true;

            while (loop == true)//so you don't have to type everytime App RevolutionDrawing
            {
                Console.WriteLine("Starting RevolutionDrawing...\n");
                Console.WriteLine("Colors:");
                Console.WriteLine("-white");
                Console.WriteLine("-light gray");
                Console.WriteLine("-dark blue");
                Console.WriteLine("-black");
                Console.WriteLine("-own color");
                Console.WriteLine("-quit");
                Console.WriteLine("Which Color do you want to use?");

                input = Console.ReadLine();

                if (input == "white") color = 2; //color index (in color.cs) for white
                else if (input == "light gray") color = 3;//color index (in color.cs) for light gray
                else if (input == "dark blue") color = 1;//color index (in color.cs) for dark blue
                else if (input == "black") color = 0;//color index (in color.cs) for black
                else if (input == "own color")
                {
                    Console.WriteLine("Type your color: (e.g. 255, 255, 255)");
                    owncolor = Console.ReadLine();

                    owncolorR = Int32.Parse(owncolor.Substring(0, 3));//parses the substring of woncolor for Red
                    owncolorG = Int32.Parse(owncolor.Substring(5, 3));//parses the substring of owncolor for Green
                    owncolorB = Int32.Parse(owncolor.Substring(10, 3));//parses the substring of owndolor for Blue

                    /* Use this for testing
                     * It works, but if an error occures use this :)
                    Console.WriteLine("Test (After Int32.Parse):");
                    Console.WriteLine("R: " + owncolorR);
                    Console.WriteLine("G: " + owncolorG);
                    Console.WriteLine("B: " + owncolorB);
                  
                    Console.WriteLine("\nTest (Substring):");
                    Console.WriteLine("R: " + owncolor.Substring(0, 3));
                    Console.WriteLine("G: " + owncolor.Substring(5, 3));
                    Console.WriteLine("B: " + owncolor.Substring(10, 3));
                    Console.ReadLine();
                     */

                    rightinput = false;
                   



                    VGAScreen.SetMode320x200x8();//Starts the gui
                    VGAScreen.Clear(0);//make a black screen color index 0 is definated in color.cs
                    Core.Graphics.Color.Make();//make all colors
                    Core.Desktop.Mouse.Initialize();//Initialzies the mouse
                    DrawOwnColor(owncolorR, owncolorG, owncolorB);

                }
                else if (input == "Help")
                {
                    Console.WriteLine("Help:\n" +
                        "Just write the color you want to use (e.g. white) or type own color, to mix your own color.");
                }
                else if (input == "quit")
                {
                    loop = false;//to stop the loop
                    rightinput = true;//don't start the GUI
                }
                else
                {
                    Console.WriteLine("Color/Command not found! Type --help for help!");
                    rightinput = false;//don't start the GUI
                }


                if (rightinput == true)
                {
                    VGAScreen.SetMode320x200x8();//Starts the gui
                    VGAScreen.Clear(0);//make a black screen color index 0 is definated in color.cs
                    Core.Graphics.Color.Make();//make all colors
                    Core.Desktop.Mouse.Initialize();//Initialzies the mouse

                    Draw((uint)color);//jumps to the void Draw
                }
            }

        }


        public static void Draw(uint color)
        {
            bool loop = true;

            while (loop == true)//so it will draw a line
            {
                uint x = (uint)Core.Desktop.Mouse.Mousex();//get Mousex and convert to uint
                uint y = (uint)Core.Desktop.Mouse.Mousey();//get Mousey and convert tu uint


                VGAScreen.SetPixel(x, y, color);//draw the pixel
                Core.Desktop.Apps.Program.Draw();
                Core.Graphics.Formsforuse.Forms.DrawBufferToScreen();
            }
        }

        public static void DrawOwnColor(int R, int G, int B)
        {
            bool loop = true;
            int color;

            while (loop == true)//so it will draw a line
            {

                uint x = (uint)Core.Desktop.Mouse.Mousex();//get Mousex and convert to uint
                uint y = (uint)Core.Desktop.Mouse.Mousey();//get Mousey and convert tu uint

                color = R + G + B;
                VGAScreen.SetPaletteEntry(color, (byte)R, (byte)G, (byte)B);
                VGAScreen.SetPixel(x, y, (uint)color);//draw the pixel

                Core.Desktop.Apps.Program.Draw();
                Core.Graphics.Formsforuse.Forms.DrawBufferToScreen();
            }
        }

    }
}
