﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace RevoluionOS.Core.Desktop.Apps.Settings
{
    class Settings
    {
        public static Resolution.Resolution Resolution = new Resolution.Resolution();
        public static bool SettingsOpen = false;
        public static bool MenuOpen = false;
        public static uint width = 200;
        public static uint height = 200;
        public static uint x = (Resolution.uwidth -width) / 2;
        public static uint y = (Resolution.uheight - height) / 2;
        public static uint distancey = 10;
        public static uint distancex = 15 ;
        public static uint Contentx = Core.Desktop.Apps.Program.Contentx + 2;
        public static uint Contenty = Core.Desktop.Apps.Program.Contenty + 2;

        public static void Open()
        {
            if (MenuOpen == true)
            {
            Draw();//draw the settings/menu app
            }
            else if (Core.Desktop.Apps.Settings.Style.StyleOpen == true)
            {
                Core.Desktop.Apps.Settings.Style.Draw();//draw the settings/style app
            }
            else if (Core.Desktop.Apps.Settings.Profile.ProfileOpen == true)
            {
                Core.Desktop.Apps.Settings.Profile.Draw();//draw the settings/profile app
            }
        }

        public static void Draw()
        {
            MenuOpen = true;
            Contentx = Core.Desktop.Apps.Program.Contentx + 2;
            Contenty = Core.Desktop.Apps.Program.Contenty + 2;

            Core.Desktop.Apps.Program.DrawSmall("Settings", x, y, height, width, 0x000000);//draw the form
            Core.Desktop.Apps.Program.DrawClose();//draw the close button

            #region " Headers "
            Core.Graphics.Font.Ownfont10x11.ConvertText("Personal:", Contentx, Contenty, 0x000000);//text for Personal
            Core.Graphics.Font.Ownfont10x11.ConvertText("Hardware:", Contentx, Contenty + 2 * distancey + 45, 0x000000);//text for hardware
            #endregion

            #region " Icons and Text "
            //Personal
            Core.Graphics.Formsforuse.Forms.Draw4Colors(Style, 30, 30, Contentx + 10, Contenty + distancey + 11, 0x383838, 0xB8B8B8, 0xFF0000, 0xffffff);//icon style
            Core.Graphics.Font.Ownfont7x8.ConvertText("Style", Contentx + 8, Contenty + distancey + 44, 0x000000);//text for style

            Core.Graphics.Formsforuse.Forms.DrawArray(Profile, 30, 30, Contentx + distancex + 40, Contenty + distancey + 11, 0x7094FF);//Profile icon color: light blue
            Core.Graphics.Font.Ownfont7x8.ConvertText("Profile", Contentx + distancex + 33, Contenty + distancey + 44, 0x000000);//text for profile
            //Hardware
            Core.Graphics.Formsforuse.Forms.Draw4Colors(Display, 30, 30, Contentx + 10, Contenty + 3 * distancey + 54, 0x878787, 0xB8B8B8, 0x0000FF, 0x000000);//icon display
            Core.Graphics.Font.Ownfont7x8.ConvertText("Display", Contentx + 3, Contenty + 3 * distancey + 87, 0x000000);//text for display
            #endregion
        }

        public static void Clicks()
        {
            if (MenuOpen == true)
            {
                ClicksMenu();//jumps to clicks in Settings/menu open app
            }
            else if (Core.Desktop.Apps.Settings.Style.StyleOpen == true)
            {
                //MenuOpen = false;//close menu
                Core.Desktop.Apps.Settings.Style.Clicks();//jumps to clicks in Settings/Style app
            }
            else if (Core.Desktop.Apps.Settings.Profile.ProfileOpen == true)
            {
                Core.Desktop.Apps.Settings.Profile.Clicks();//jumps to clicks in Settings/Profile app
            }
        }

        public static void ClicksMenu()
        {
            if (Core.Desktop.Mouse.LeftClick((int)x + (int)width - 17, (int)y + 6, 10, 10) == true)
            {
                SettingsOpen = false;//close app
                MenuOpen = false;
            }
            else if (Core.Desktop.Mouse.LeftClick((int)Contentx + 8, (int)Contenty + (int)distancey + 11, 34, 39) == true)
            {
                MenuOpen = false;//close the menu
                Core.Desktop.Apps.Settings.Style.StyleOpen = true;//open the Style
            }
            else if (Core.Desktop.Mouse.LeftClick((int)Contentx + (int)distancex + 33, (int)Contenty + (int)distancey + 11, 48, 39) == true)
            {
                MenuOpen = false;//close the menu
                Core.Desktop.Apps.Settings.Profile.ProfileOpen = true;//open the profile
            }
            else if (Core.Desktop.Mouse.LeftClick((int)Contentx + 3, (int)Contenty + 3 * (int)distancey + 54, 48, 39) == true)
            {
                MenuOpen = false;//close the menu
            }
        }

        public static uint[] Display = {
                               1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
                               1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
                               1,1,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,1,1,
                               1,1,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,1,1,
                               1,1,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,1,1,
                               1,1,4,4,4,4,4,4,4,4,4,4,4,4,4,3,3,3,3,3,3,3,3,3,3,4,4,4,1,1,
                               1,1,4,4,4,4,4,4,4,4,4,4,4,4,3,3,3,3,3,3,3,3,3,3,3,4,4,4,1,1,
                               1,1,4,4,4,4,4,4,4,4,4,4,4,3,3,3,3,3,3,3,3,3,3,3,3,4,4,4,1,1,
                               1,1,4,4,4,4,4,4,4,4,4,4,3,3,3,3,3,3,3,3,3,3,3,3,3,4,4,4,1,1,
                               1,1,4,4,4,4,4,4,4,4,4,3,3,3,3,3,3,3,3,3,3,3,3,3,3,4,4,4,1,1,
                               1,1,4,4,4,4,4,4,4,4,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,4,4,4,1,1,
                               1,1,4,4,4,4,4,4,4,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,4,4,4,1,1,
                               1,1,4,4,4,4,4,4,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,4,4,4,1,1,
                               1,1,4,4,4,4,4,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,4,4,4,1,1,
                               1,1,4,4,4,4,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,4,4,4,1,1,
                               1,1,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,1,1,
                               1,1,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,1,1,
                               1,1,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,1,1,
                               1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
                               1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
                               0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
                               0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
                               0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
                               0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
                               0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
                               0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
                               0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,
                               0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,
                               0,0,0,0,0,0,0,0,0,0,2,2,2,2,0,0,2,2,2,2,0,0,0,0,0,0,0,0,0,0,
                               0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0};

        public static uint[] Style = {
			                   2,2,2,2,1,1,4,4,4,4,1,1,1,1,1,1,1,1,1,1,4,4,4,4,1,1,2,2,2,2,
                               2,2,2,2,2,1,1,4,4,4,4,1,1,1,1,1,1,1,1,4,4,4,4,1,1,2,2,2,2,2,
                               2,2,2,2,1,1,1,4,4,4,4,4,4,1,1,1,1,1,4,4,4,4,4,1,1,1,2,2,2,2,
                               2,2,2,1,1,2,2,1,4,4,4,4,1,3,3,3,3,1,4,4,4,4,1,2,2,1,1,2,2,2,
                               2,2,1,1,2,2,2,1,4,4,1,1,3,3,3,3,3,3,1,1,4,4,1,2,2,2,1,1,2,2,
                               2,1,1,2,2,2,2,2,1,1,4,3,3,3,3,3,3,3,3,4,1,1,2,2,2,2,2,1,1,2,
                               2,2,1,1,2,2,2,2,1,4,4,4,3,3,3,3,3,3,4,4,4,1,2,2,2,2,1,1,2,2,
                               2,2,2,1,1,2,2,2,2,1,4,4,4,3,3,3,3,4,4,4,1,2,2,2,2,1,1,2,2,2,
                               2,2,2,2,1,1,2,2,2,1,4,4,4,3,3,3,3,4,4,4,1,2,2,2,1,1,2,2,2,2,
                               2,2,2,2,2,1,1,2,2,2,1,4,3,3,3,3,3,3,4,1,2,2,2,1,1,2,2,2,2,2,
                               2,2,2,2,2,2,1,1,2,2,1,3,3,3,3,3,3,3,3,1,2,2,1,1,2,2,2,2,2,2,
                               2,2,2,2,2,2,2,1,1,2,2,1,3,3,3,3,3,3,1,2,2,1,1,2,2,2,2,2,2,2,
                               2,2,2,2,2,2,2,2,1,1,2,1,3,3,3,3,3,3,1,2,1,1,2,2,2,2,2,2,2,2,
                               2,2,2,2,2,2,2,2,2,1,1,2,1,3,3,3,3,1,2,1,1,2,2,2,2,2,2,2,2,2,
                               2,2,2,2,2,2,2,2,2,2,1,1,1,3,3,3,3,1,1,1,2,2,2,2,2,2,2,2,2,2,
                               2,2,2,2,2,2,2,2,2,2,2,1,1,1,3,3,1,1,1,2,2,2,2,2,2,2,2,2,2,2,
                               2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,
                               2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,
                               2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,
                               2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,
                               2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,
                               2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,
                               2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,
                               2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,
                               2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,
                               2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,
                               2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,
                               2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,
                               2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,
                               2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2};

        public static uint[] Profile = {
                               0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,
                               0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,
                               0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,
                               0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,
                               0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,
                               0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,
                               0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,
                               0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,
                               0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,
                               0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,
                               0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,
                               0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,
                               0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,
                               0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,
                               0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
                               0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
                               0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,
                               0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,
                               0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,
                               0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,
                               0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,
                               0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,
                               0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,
                               0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,
                               0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,
                               0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,
                               0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,
                               0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,
                               0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,
                               0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0};
    }
}
