﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace RevoluionOS.Core.Graphics
{
    class Buffer
    {
        /* 
         * Use this if the screen flickers
         * Credtis: PearOS (Matt/civilwarrock) (He gave me the idea to use buffers, and I also took a look in the Pear OS buffering system)
         * I'll make an own buffering system, but now I'll use that one, which is copied (not all) from pear OS
         * Check out: pearos.codeplex.com -it's awesome!
         */



        public uint[] Data;
        public int Height;
        public int Width;


        public Buffer(uint width, uint height)
        {
            this.Width = (int)width;
            this.Height = (int)height;
            this.Data = new uint[(Height + 1) * (Width + 1)];
        }

        Buffer()
        {
            this.Width = 0;
            this.Height = 0;
            this.Data = new uint[(this.Height + 1) * (this.Width + 1)];
        }


        public int FindPixel(int x, int y, int width, int height)
        {
            int Width2 = height;
            int Height2 = width;
            uint Found;

            if (Width2 > Height2)
            {
                /*
                 * This does not work and I will have to fix it.
                 */

                Found = (uint)(x * Width2 + y);
                return (int)Found;
            }
            if (Width2 < Height2)
            {
                /*
                 * This implentation works.
                 */
                Found = (uint)(y * Height2 + x);
                return (int)Found;
            }
            if (Width2 == Height2)
            {
                /*
                 * I believe this one works.
                 */
                Found = (uint)(y * Height2 + x);
                return (int)Found;
            }
            return 0;
        }


        public uint GetPixel(uint n)
        {
            return this.Data[n];
        }
        public int GetPixel(int n)
        {
            return (int)this.Data[n];
        }
        /// <summary>
        /// SetPixel method.
        /// </summary>
        /// <param name="c"></param>
        /// <param name="n"></param>
        public void SetPixel(uint c, uint n)
        {
            this.Data[n] = c;
        }
        public void SetPixel(int c, int n)
        {
            this.Data[n] = (uint)c;
        }
    }
}
