﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using RevoluionOS.Core.Resolution.Driver;

namespace RevoluionOS.Core.Graphics
{
    class Forms
    {
        public Cosmos.Hardware.VGAScreen VGAScreen = new Cosmos.Hardware.VGAScreen();
        public static Core.Resolution.Resolution Resolution = new Resolution.Resolution();
        public Core.Graphics.Buffer Buffer = new Buffer(Resolution.uwidth, Resolution.uheight);
        private static Core.Resolution.Driver.VMware VMware = new Resolution.Driver.VMware();

        public int Width = Resolution.width;
        public int Height = Resolution.height;


        public void Rectangle(uint x, uint y, uint width, uint height, int color)
        {
            Screen.DrawRectangle((int)x, (int)y, (int)width, (int)height, (int)color);
        }

        /*public void Rectangle(int x, int y, int width, int length, uint color)
        {
            for (bb = x; bb < x + width; bb++)
            {
                for (cc = y; cc < y + length; cc++)
                {
                    SetPixel(bb, cc, color);
                }
            }
        }
         */


        public void DrawRectangle(uint x, uint y, uint width, uint length, int color)
        {
            Screen.DrawRectangle((int)x, (int)y, (int)width, (int)length, (int)color);
        }

        public void SetPixel(int x, int y, int Color)
        {
            //Core.Resolution.Driver.VMware_use.SetPixel(x, y, Color);
        }  

        public void ClearBufferToSystemColor(int color)
        {
            /*
             * Set all the pixel in the buffer to a system color.
             */
            uint width = (uint)Buffer.Height;
            uint height = (uint)Buffer.Width;
            if (width > height)
            {
                for (uint x = 0; x < height; x++)
                {
                    for (uint y = 0; y < width; y++)
                    {
                        SetColorInBuffer(x, y, (uint)color);
                    }

                }
            }
            if (width == height)
            {
                for (uint x = 0; x < height; x++)
                {
                    for (uint y = 0; y < width; y++)
                    {
                        SetColorInBuffer(x, y, (uint)color);
                    }

                }
            }
            if (width < height)
            {

                for (uint y = 0; y < width; y++)
                {
                    for (uint x = 0; x < height; x++)
                    {
                        SetColorInBuffer(x, y, (uint)color);
                    }
                }
            }
        }



        private uint Found = 0;
        /*
         * This is used to calculate the position of a pixel based off of a X and Y in a buffer, or as we call them Frame's.
         */
        public uint FindPixel(uint xpos, uint ypos, uint width, uint height)
        {
            /*
             * Ok so we store the pixl in the buffer in a few different ways
             * but to find out what number in the array will be that pixel
             * we loop through a for event, well thats bad, because it will slow
             * down the system, this exquation will find it for ten times faster. Making
             * pear speedy. - Matt
             */
            uint Width2 = height;
            uint Height2 = width;
            if (Width2 > Height2)
            {
                /*
                 * This does not work and I will have to fix it.
                 */
                Found = xpos * Width2 + ypos;
                return Found;
            }
            if (Width2 < Height2)
            {
                /*
                 * This implentation works.
                 */
                Found = ypos * Height2 + xpos;
                return Found;
            }
            if (Width2 == Height2)
            {
                /*
                 * I believe this one works.
                 */
                Found = ypos * Height2 + xpos;
                return Found;
            }
            return 0;
        }
        public int FindPixel(int xpos, int ypos, int width, int height)
        {
            /*
             * Ok so we store the pixl in the buffer in a few different ways
             * but to find out what number in the array will be that pixel
             * we loop through a for event, well thats bad, because it will slow
             * down the system, this exquation will find it for ten times faster. Making
             * pear speedy. - Matt
             */
            int Width2 = height;
            int Height2 = width;
            if (Width2 > Height2)
            {
                /*
                 * This does not work and I will have to fix it.
                 */

                Found = (uint)(xpos * Width2 + ypos);
                return (int)Found;
            }
            if (Width2 < Height2)
            {
                /*
                 * This implentation works.
                 */
                Found = (uint)(ypos * Height2 + xpos);
                return (int)Found;
            }
            if (Width2 == Height2)
            {
                /*
                 * I believe this one works.
                 */
                Found = (uint)(ypos * Height2 + xpos);
                return (int)Found;
            }
            return 0;
        }

        public void SetColorInBuffer(uint xpos, uint ypos, uint color)
        {
            /*
             * Add the code for setting a pixel into the buffer. Also known as double buffering. What we are going
             * to do is draw to the buffer, and at the end, draw the entire buffer to the screen updating it, this way
             * you dont see some things getting updated and others not.
             */
            Buffer.SetPixel(color, FindPixel(xpos, ypos, (uint)Buffer.Width, (uint)Buffer.Height));
        }
        public void SetColorInBuffer(int xpos, int ypos, int color)
        {
            /*
             * Add the code for setting a pixel into the buffer. Also known as double buffering. What we are going
             * to do is draw to the buffer, and at the end, draw the entire buffer to the screen updating it, this way
             * you dont see some things getting updated and others not.
             */
            Buffer.SetPixel(color, (int)FindPixel((uint)xpos, (uint)ypos, (uint)Buffer.Width, (uint)Buffer.Height));
        }

        public void DrawArray(uint[] Arr, int width, int length, uint xpixel, uint ypixel, uint color)//This function draws the Array
        {
            Screen.DrawFrameColor(Arr, width, length, (int)xpixel, (int)ypixel, (int)color);

            /*uint x = 0, y = 0;
            int texnumwid = 0;
            int textnumlen = 0;
            int i;
            int t;
            int count = 0;
            for (i = 0; i < length; i++)
            {
                for (t = 0; t < width; t++, count++)
                {
                    if (Arr[count] == 1)
                    {
                        SetPixelInBuffer(x + (uint)t + (uint)texnumwid + (uint)xpixel, y + (uint)i + (uint)textnumlen + (uint)ypixel, color);
                    }
                }
            }
             */
        }



        public void DrawBlackWhite(uint[] Arr, int width, int length, uint xpixel, uint ypixel)//This function draws the Array
        {
            Screen.DrawFrameBlackAndWhite(Arr, width, length, (int)xpixel, (int)ypixel);
            /*uint x = 0, y = 0;
            int texnumwid = 0;
            int textnumlen = 0;
            int i;
            int t;
            int count = 0;
            for (i = 0; i < length; i++)
            {
                for (t = 0; t < width; t++, count++)
                {
                    if (Arr[count] == 1)
                    {
                        SetPixelInBuffer(x + (uint)t + (uint)texnumwid + (uint)xpixel, y + (uint)i + (uint)textnumlen + (uint)ypixel, 0);
                    }
                    else if (Arr[count] == 2)
                    {
                        SetPixelInBuffer(x + (uint)t + (uint)texnumwid + (uint)xpixel, y + (uint)i + (uint)textnumlen + (uint)ypixel, 2);
                    }
                }
            }
             */
        }

        public void Draw2Colors(uint[] Arr, int width, int length, uint xpixel, uint ypixel, uint color1, uint color2)
        {
            Screen.DrawFrame2Colors(Arr, width, length, (int)xpixel, (int)ypixel, (int)color1, (int)color2);
            /*uint x = 0, y = 0;
            int texnumwid = 0;
            int textnumlen = 0;
            int i;
            int t;
            int count = 0;
            for (i = 0; i < length; i++)
            {
                for (t = 0; t < width; t++, count++)
                {
                    if (Arr[count] == 1)
                    {
                        SetPixelInBuffer(x + (uint)t + (uint)texnumwid + (uint)xpixel, y + (uint)i + (uint)textnumlen + (uint)ypixel, color1);
                    }
                    else if (Arr[count] == 2)
                    {
                        SetPixelInBuffer(x + (uint)t + (uint)texnumwid + (uint)xpixel, y + (uint)i + (uint)textnumlen + (uint)ypixel, color2);
                    }
                }
            }
             */
        }


        public void Draw3Colors(uint[] Arr, int width, int length, uint xpixel, uint ypixel, uint color1, uint color2, uint color3)
        {
            Screen.DrawFrame3Colors(Arr, width, length, (int)xpixel, (int)ypixel, (int)color1, (int)color2, (int) color3);
            /*int x = 0, y = 0;
            int texnumwid = 0;
            int textnumlen = 0;
            int i;
            int t;
            int count = 0;
            for (i = 0; i < length; i++)
            {
                for (t = 0; t < width; t++, count++)
                {
                    if (Arr[count] == 1)
                    {
                        SetPixel(x + t + texnumwid + (int)xpixel, y + i + textnumlen + (int)ypixel, (int)color1);
                    }
                    else if (Arr[count] == 2)
                    {
                        SetPixel(x + t + texnumwid + (int)xpixel, y + i + textnumlen + (int)ypixel, (int)color2);
                    }
                    else if (Arr[count] == 3)
                    {
                        SetPixel(x + t + texnumwid + (int)xpixel, y + i + textnumlen + (int)ypixel, (int)color3);
                    }
                }
            }
             */
        }

        public void Draw4Colors(uint[] Arr, int width, int length, uint xpixel, uint ypixel, uint color1, uint color2, uint color3, uint color4)
        {
            Screen.DrawFrame4Colors(Arr, width, length, (int)xpixel, (int)ypixel, (int)color1, (int)color2, (int)color3, (int)color4);
        }

        public void SetPixelInBuffer(uint x, uint y, uint color)
        {
            SetPixel((int)x, (int)y, (int) color);
            //We don't need this buffer anymore
            //Buffer.SetPixel(color, (uint)Buffer.FindPixel((int)x, (int)y, Buffer.Width, Buffer.Height)); 
        }

        public void DrawBufferToScreen()
        {
            /*
             * Draw the buffer to the screen
             */
            RestoreFrame(0, 0, Buffer);
        }

        public void RestoreFrame(uint xpos, uint ypos, Core.Graphics.Buffer image)
        {
            Core.Resolution.Driver.VMware VMware = new Core.Resolution.Driver.VMware();
            //inverted.
            uint width = (uint)image.Height;
            uint height = (uint)image.Width;
            if (width > height)
            {
                uint n = 0;
                for (uint x = 0; x < height; x++)
                {
                    for (uint y = 0; y < width; y++)
                    {
                        SetPixel((int)(xpos + x), (int)(ypos + y), (int)image.GetPixel(n));
                        n += 1;
                    }

                }
            }
            if (width == height)
            {
                uint n = 0;
                for (uint x = 0; x < height; x++)
                {
                    for (uint y = 0; y < width; y++)
                    {
                        //Commented out this: xpos + x, ypos + y,
                        SetPixel((int)(xpos + x), (int)(ypos + y), (int)image.GetPixel(n));
                        n += 1;
                    }

                }
            }
            if (width < height)
            {
                uint n = 0;
                for (uint y = 0; y < width; y++)
                {
                    for (uint x = 0; x < height; x++)
                    {
                        //Commented out this: xpos + x, ypos + y,
                        SetPixel((int)(xpos + x), (int)(ypos + y), (int)image.GetPixel(n));
                        n += 1;
                    }

                }
            }
        }


       

       /* public void SetPixel(uint x, uint y, uint color)
        {
            ushort ux = (ushort)x;
            ushort uy = (ushort)y;
            VMware.SetPixel(ux, uy, color);
        }
        */

       /* public void SetPixel(int x, int y, int Color)
        {
            VMware.SetPixel((ushort)x, (ushort)y, (uint)Color);
        }

        */
    }
}
