﻿using System;
using System.Collections.Generic;
using System.Text;
using Sys = Cosmos.System;

namespace RevoluionOS
{
    public class Kernel : Sys.Kernel
    {   
        /* Name: RevolutionOS
         * Author: TheKleini666 (Thiemo Klein) (Revolution-Apps)
         * Started: 12.02.2012
         * Description: An operating system made with Cosmos
         * Credits:
         * Buffer           -PearOS (Matt, civilwarrock) (pearos.codeplex.com) (Matt gave me the idea to use buffers, and I also took a look at the PearOS buffering system!)
         * ColorPallete     -http://www.w3schools.com/tags/ref_color_tryit.asp (Matt gave me the link)
         */

        public static bool loop = true;

        protected override void BeforeRun()
        {
            Console.WriteLine("Booting RevolutionOS...");
            Console.WriteLine("Starting Screen...");

            //We don't need the Cosmos VGAScreen anymore, because we use the VMWare driver from PearOS
            //VGAScreen.SetMode320x200x8();//starts vga screen
            Core.Resolution.Driver.Screen.SetDriver(Core.Resolution.Driver.Screen.Driver.VMWareSVGA);
            Core.Resolution.Driver.Screen.SetMode(Core.Resolution.Driver.Screen.Resolutions.Resolution3_800);

            #region " Booting screen "
            //Draw booting screen
            Core.Boot.Boot.Draw();
            Core.Boot.Boot.percentage = 50;
            Core.Resolution.Driver.Screen.Update();

            Core.Boot.Boot.Text = "Starting mouse";
            Core.Boot.Boot.Draw();
            Core.Desktop.Mouse.Start();//Starts the mouse
            Core.Boot.Boot.percentage = 100;
            Core.Resolution.Driver.Screen.Update();

            Core.Boot.Boot.Text = "Starting Login screen";
            Core.Boot.Boot.Draw();
            Core.Resolution.Driver.Screen.Update();
            #endregion

            do
            {
                //Draw Login screen
                Core.Login.Screen.Login();
                //updates the mouse
                Core.Desktop.Mouse.Draw();
                //update the screen
                Core.Resolution.Driver.Screen.Update();
            } while (loop == true);

            //Core.Login.Screen.Login();//jumps to the login screen
            Core.Desktop.Desktop.Loading();//loads gui

            #region " OLD CODE - DO NOT DELETE "
            /*
            Console.WriteLine("RevolutionOS booted successfully. It's a cosmos distrubtion.");

            Cosmos.Hardware.VGAScreen VGAScreen = new Cosmos.Hardware.VGAScreen();

            Console.WriteLine("Type --help for help!");

            while (loop == true)
            {
                Console.Write("RevolutionOS: ");
                var input = Console.ReadLine();

                if (input == "--help" || input == "help")
                {
                    Console.WriteLine("Help:");
                    Console.WriteLine("1. startd            -starts the Desktopversion");
                    Console.WriteLine("2. about             -about RevolutionOS");
                    Console.WriteLine("3. help              -displays all commands");
                    Console.WriteLine("4. time              -shows the current time");
                    Console.WriteLine("5. date              -shows the current date (Format: DD/MM/YYYY)");
                    Console.WriteLine("6. RevolutionDrawing -Starts the App RevolutionDrawing");
                }
                else if (input == "startd")
                {
                    loop = false;
                    //We don't need the Cosmos VGAScreen anymore, because we use the VMWare driver from PearOS
                    //VGAScreen.SetMode320x200x8();//starts vga screen
                    Core.Resolution.Driver.Screen.SetDriver(Core.Resolution.Driver.Screen.Driver.VMWareSVGA);
                    Core.Resolution.Driver.Screen.SetMode(Core.Resolution.Driver.Screen.Resolutions.Resolution3_800);
                    
                    //Don't need this anymore!
                    //Core.Graphics.Color.Make();//Make all colors which are needed

                    Core.Desktop.Mouse.Start();//Starts the mouse
                    //Core.Login.Screen.Login();//jumps to the login screen
                    Core.Desktop.Desktop.Loading();//loads gui

                }
                else if (input == "pw")
                {
                    Console.WriteLine(Core.Password.Passwd.Password);
                    input = Console.ReadLine();
                    Core.Password.Passwd.SavePW(input);
                    Console.WriteLine(input);
                    Console.WriteLine(Core.Password.Passwd.Password);
                }
                else if (input == "about")
                {
                    Console.WriteLine("\nName: " + Core.RevolutionOS.About.Name);
                    Console.WriteLine("Version: " + Core.RevolutionOS.About.Version);
                    Console.WriteLine("Author: " + Core.RevolutionOS.About.Author1);
                    Console.WriteLine("Homepage: " + Core.RevolutionOS.About.Homepage + "\n");
                }
                else if (input == "time")
                {
                    Console.WriteLine("It is " + Core.Apps.Clock.currentTime() + ".");
                }
                else if (input == "date")
                {
                    //Console.WriteLine("Today is " + Core.Apps.Clock.DayOfWeek() + "!"); //-Doesn't work with lapyears!
                    Console.WriteLine(Core.Apps.Clock.CurrentDate() + " (DD/MM/YY)");
                }
                else if (input == "RevolutionDrawing")
                {
                    Core.Desktop.Apps.RevolutionDrawing.start();//starts RevolutionDrawing
                }
                else Console.WriteLine("Command not found! Type --help for help!");
            }
            */
            #endregion
        }

        protected override void Run()
        {
            
            //Core.Resolution.Driver.VMware.SetMode(800, 600);
            //loads the gui
            Core.Desktop.Desktop.Loading();
            
            //Open Apps/Games/...
            Core.Desktop.Mouse.Clicks();

            //updates the mouse
            Core.Desktop.Mouse.Draw();

            //update the screen
            Core.Resolution.Driver.Screen.Update();
        }
    }
}
